#include "nrf.h"
#include "nrf_gpio.h"

static const uint32_t LED1 = 17ul;
static const uint32_t BTN1 = 13ul;
static const uint32_t GPIOTE_CHANNEL_0 = 0ul;

static const uint32_t NRF_APP_PRIORITY_LOW = 3ul;

void GPIOTE_IRQHandler()
{
  NRF_GPIOTE->EVENTS_IN[GPIOTE_CHANNEL_0] = 0;
  nrf_gpio_pin_toggle(LED1);
}

int main()
{
  NVIC_SetPriority(DebugMonitor_IRQn, 7ul);
  NVIC_SetPriority(GPIOTE_IRQn, 1ul);
  
  nrf_gpio_cfg_output(LED1);
  nrf_gpio_cfg_input(BTN1, NRF_GPIO_PIN_PULLUP);
  
  NVIC_DisableIRQ(GPIOTE_IRQn);
  NVIC_ClearPendingIRQ(GPIOTE_IRQn);
  
  NRF_GPIOTE->CONFIG[GPIOTE_CHANNEL_0] =    (GPIOTE_CONFIG_POLARITY_HiToLo << GPIOTE_CONFIG_POLARITY_Pos)
                                          | (BTN1 << GPIOTE_CONFIG_PSEL_Pos) 
                                          | (GPIOTE_CONFIG_MODE_Event << GPIOTE_CONFIG_MODE_Pos);
  
  NRF_GPIOTE->EVENTS_IN[GPIOTE_CHANNEL_0] = 0; /* Clear the event that appears in some cases */
  NRF_GPIOTE->INTENSET  = GPIOTE_INTENSET_IN0_Set << GPIOTE_INTENSET_IN0_Pos;
  NVIC_EnableIRQ(GPIOTE_IRQn);

  volatile int i = 0;
  
  while(1)
  {
    i++;
    if (i > 10)
      i = 0;
    // Do nothing.
  }
}
